//----------------------------------------------------------------------------
// SlideBar.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: SlideBar.pas
//----------------------------------------------------------------------------
#ifndef SlideBarHPP
#define SlideBarHPP
//----------------------------------------------------------------------------
#include <zAnimate.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Slidebar
{
//-- type declarations -------------------------------------------------------
enum TBarStyle { bsLowered, bsRaised };

typedef int TBarTick;

enum TBarTickStyle { ttsLeft, ttsRight, ttsBoth };

enum TOrientation { orVertical, orHorizontal };

enum TzTickStyle { tsNormal, tsOwnerDraw };

enum TThumbStyle { tsHorzHigh, tsVertHigh, tsHorzLow, tsVertLow, tsSquare, tsSquarehollow, tsLeft, tsRight, 
	tsTop, tsBottom, tsRound, tsHorzRound, tsSquarehollowHorz, tsSquarehollowVert, tsSquarehollowHLine, 
	tsSquarehollowVLine };

typedef void __fastcall (__closure *TsSlideTickOwnerDraw)(Graphics::TCanvas* Canvas, int X, int Y, bool 
	Left, long TickNum);

class __declspec(delphiclass) TzSlideBar;
class __declspec(pascalimplementation) TzSlideBar : public Controls::TCustomControl
{
	typedef Controls::TCustomControl inherited;
	
private:
	bool FMoved;
	bool FAutoFocus;
	bool FJumpToMouse;
	TsSlideTickOwnerDraw FOwnerDraw;
	TzTickStyle FTickStyle;
	Graphics::TColor FColor;
	bool FSteel;
	bool FTicks;
	TBarTickStyle FTickWhere;
	int FTickSpace;
	int FTickSize;
	TBarTick FStepPerTick;
	Graphics::TColor FFocusColor;
	Graphics::TColor FNonFocusColor;
	Classes::TStringList* FLabels;
	int FMax;
	int FMin;
	int FPosition;
	TOrientation FOrientation;
	TBarStyle FStyle;
	Byte FThickness;
	TThumbStyle FThumbStyle;
	Classes::TNotifyEvent FOnChange;
	Classes::TNotifyEvent FOnMinimum;
	Classes::TNotifyEvent FOnMaximum;
	Graphics::TBitmap* ThumbBmp;
	Graphics::TBitmap* MaskBmp;
	int DragVal;
	int HalfTW;
	int HalfTH;
	Windows::TRect ThumbRect;
	HDC TempDC;
	Classes::TNotifyEvent FOnEnter;
	Classes::TNotifyEvent FOnLeave;
	Controls::TMouseEvent fOnMouseUpTwo;
	void __fastcall SetLabels(Classes::TStringList* A);
	void __fastcall SetMax(int A);
	void __fastcall SetTickSpace(int A);
	void __fastcall SetTickSize(int A);
	void __fastcall SetMin(int A);
	void __fastcall SetStepPerTick(TBarTick A);
	void __fastcall SetTickWhere(TBarTickStyle A);
	void __fastcall SetOrientation(TOrientation A);
	void __fastcall SetPosition(int A);
	void __fastcall SetStyle(TBarStyle A);
	void __fastcall SetThickness(Byte A);
	void __fastcall SetThumbStyle(TThumbStyle A);
	void __fastcall SetTicks(bool A);
	HIDESBASE MESSAGE void __fastcall CMEnter(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall CMExit(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Message);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	virtual void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	void __fastcall SetFocusColor(Graphics::TColor A);
	void __fastcall SetNonFocusColor(Graphics::TColor A);
	void __fastcall SetSteel(bool Value);
	HIDESBASE void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetTickStyle(TzTickStyle A);
	
protected:
	bool Dragging;
	virtual void __fastcall Paint(void);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	HIDESBASE MESSAGE void __fastcall wmEraseBkGnd(Messages::TWMEraseBkgnd &Message);
	virtual int __fastcall NewPosition(int WhereX, int WhereY);
	virtual bool __fastcall IsVert(void);
	virtual void __fastcall WhereIsBar(void);
	virtual void __fastcall SetTLColor(Graphics::TCanvas* T);
	virtual void __fastcall SetBRColor(Graphics::TCanvas* T);
	void __fastcall DoMask(void);
	void __fastcall MakeType1(void);
	void __fastcall MakeType2(void);
	void __fastcall MakeType3(void);
	void __fastcall MakeType4(void);
	void __fastcall MakeType5(void);
	void __fastcall MakeType6(void);
	void __fastcall MakeType7(void);
	void __fastcall MakeType8(void);
	void __fastcall MakeType9(void);
	void __fastcall MakeType0(void);
	void __fastcall MakeTypeA(void);
	void __fastcall MakeTypeB(void);
	void __fastcall MakeTypeC(bool LineO);
	void __fastcall MakeTypeD(bool LineO);
	
public:
	__fastcall virtual TzSlideBar(Classes::TComponent* AOwner);
	__fastcall virtual ~TzSlideBar(void);
	System::AnsiString __fastcall CurrentLabel(void);
	
__published:
	__property bool JumpToMouse = {read=FJumpToMouse, write=FJumpToMouse, default=1};
	__property bool AutoFocus = {read=FAutoFocus, write=FAutoFocus, default=0};
	__property Classes::TNotifyEvent OnMouseEnter = {read=FOnEnter, write=FOnEnter};
	__property Classes::TNotifyEvent OnMouseLeave = {read=FOnLeave, write=FOnLeave};
	__property Controls::TMouseEvent OnMouseUpTwo = {read=fOnMouseUpTwo, write=fOnMouseUpTwo};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=-2147483633};
	__property bool SteelLook = {read=FSteel, write=SetSteel, default=0};
	__property int TickSpace = {read=FTickSpace, write=SetTickSpace, default=3};
	__property int TickSize = {read=FTickSize, write=SetTickSize, default=4};
	__property TzTickStyle TickStyle = {read=FTickStyle, write=SetTickStyle, default=0};
	__property TBarTickStyle TickWhere = {read=FTickWhere, write=SetTickWhere, default=2};
	__property TBarTick StepPerTick = {read=FStepPerTick, write=SetStepPerTick, default=1};
	__property Graphics::TColor FocusColor = {read=FFocusColor, write=SetFocusColor, default=-2147483646
		};
	__property Graphics::TColor NonFocusColor = {read=FNonFocusColor, write=SetNonFocusColor, default=-2147483633
		};
	__property Classes::TStringList* Labels = {read=FLabels, write=SetLabels, nodefault};
	__property int Max = {read=FMax, write=SetMax, default=10};
	__property int Min = {read=FMin, write=SetMin, default=0};
	__property TOrientation Orientation = {read=FOrientation, write=SetOrientation, default=1};
	__property int Value = {read=FPosition, write=SetPosition, default=0};
	__property Byte Thickness = {read=FThickness, write=SetThickness, default=2};
	__property TThumbStyle ThumbStyle = {read=FThumbStyle, write=SetThumbStyle, default=1};
	__property bool Ticks = {read=FTicks, write=SetTicks, default=1};
	__property TBarStyle Style = {read=FStyle, write=SetStyle, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Classes::TNotifyEvent OnMinimum = {read=FOnMinimum, write=FOnMinimum};
	__property Classes::TNotifyEvent OnMaximum = {read=FOnMaximum, write=FOnMaximum};
	__property TabStop ;
	__property Height ;
	__property ParentShowHint ;
	__property Enabled ;
	__property Cursor ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property Visible ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnMouseMove ;
	__property TsSlideTickOwnerDraw OnOwnerDraw = {read=FOwnerDraw, write=FOwnerDraw};
public:
	/* TWinControl.CreateParented */ __fastcall TzSlideBar(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Slidebar */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Slidebar;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SlideBar
